DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
DPMParametricMapBase Class Reference

Class for managing the Parametric Map IOD attributes. More...

Inheritance diagram for DPMParametricMapBase:

## Public Member Functions
virtual | ~DPMParametricMapBase ()
| Virtual Destructor.
virtual OFCondition | saveFile (const OFString &filename, const E_TransferSyntax writeXfer=EXS_LittleEndianExplicit)
| Save current object to given filename. More...
OFCondition | writeDataset (DcmItem &dataset)
| Write current object to given item. More...
virtual OFBool | check ()
| Perform some basic checking. More...
virtual FGInterface & | getFunctionalGroups ()
| Get access to functional groups. More...
virtual IODPatientModule & | getIODPatientModule ()
| Get Patient Module. More...
virtual IODGeneralStudyModule & | getIODGeneralStudyModule ()
| Get General Study Module. More...
virtual IODPatientStudyModule & | getIODPatientStudyModule ()
| Get Patient Study Module. More...
virtual IODGeneralSeriesModule & | getIODGeneralSeriesModule ()
| Get General Series Module. More...
virtual DPMParametricMapSeriesModule & | getDPMParametricMapSeriesModule ()
| Get Parametric Map Series Module. More...
virtual IODGeneralEquipmentModule & | getIODGeneralEquipmentModule ()
| Get General Equipment Module. More...
virtual IODEnhGeneralEquipmentModule & | getIODEnhGeneralEquipmentModule ()
| Get Enhanced General Equipment Module. More...
virtual IODGeneralImageModule & | getIODGeneralImageModule ()
| Get General Image Module. More...
virtual DPMParametricMapImageModule & | getDPMParametricMapImageModule ()
| Get Parametric Map Image Module. More...
virtual IODMultiFrameFGModule & | getIODMultiFrameFGModule ()
| Get Multi-frame Functional Groups Module. More...
virtual IODMultiframeDimensionModule & | getIODMultiframeDimensionModule ()
| Get Multi-frame Dimension Module. More...
virtual IODAcquisitionContextModule & | getIODAcquisitionContextModule ()
| Get Acquisition Context Module. More...
virtual IODCommonInstanceReferenceModule & | getIODCommonInstanceReferenceModule ()
| Get Common Instance Reference Module. More...
virtual IODSOPCommonModule & | getIODSOPCommonModule ()
| Get SOP Common Module. More...
Public Member Functions inherited from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 >, IODFloatingPointImagePixelModule, IODDoubleFloatingPointImagePixelModule >
| DcmIODImage ()
| Constructor, creates new DcmIODImage instance with integer-based pixel data.
| DcmIODImage (OFin_place_type_t(ImagePixel))
| Constructor, constructs new DcmIODImage instance with integer, float or double based Image Pixel Module (i. More...
virtual | ~DcmIODImage ()
| Virtual Destructor.
virtual void | setValueCheckOnWrite (const OFBool doCheck)
| Set whether attribute values should be checked on writing, i.e. More...
IODGeneralImageModule & | getGeneralImage ()
| Get General Image Module. More...
IODImagePixelModuleType & | getImagePixel ()
| Get Image Pixel Module (variant) More...
Public Member Functions inherited from DcmIODCommon
| DcmIODCommon ()
| Constructor.
| DcmIODCommon (const DcmIODCommon &rhs)
| Copy Constructor. More...
OFshared_ptr< IODRules > | getRules ()
| Get rules handled by this IOD. More...
OFshared_ptr< DcmItem > | getData ()
| Get item managed by this IOD. More...
IODPatientModule & | getPatient ()
| Get Patient Module. More...
IODPatientStudyModule & | getPatientStudy ()
| Get Patient Study Module. More...
IODGeneralStudyModule & | getStudy ()
| Get General Study Module. More...
IODGeneralEquipmentModule & | getEquipment ()
| Get General Equipment Module. More...
IODGeneralSeriesModule & | getSeries ()
| Get Series Module. More...
IODFoRModule & | getFrameOfReference ()
| Get Frame of Reference Module. More...
IODSOPCommonModule & | getSOPCommon ()
| Get SOP Common Module. More...
IODCommonInstanceReferenceModule & | getCommonInstanceReference ()
| Get Common Instance Reference Module. More...
virtual | ~DcmIODCommon ()
| Destructor.
virtual void | createNewStudy (const OFBool clearEquipment=OFTrue)
| Create new study. More...
virtual void | createNewSeries (const OFBool clearFoR=OFTrue)
| Create a new series. More...
virtual void | createNewSOPInstance ()
| Create a new SOP instance. More...
virtual void | ensureInstanceUIDs (const OFBool correctInvalid=OFFalse)
| Make sure that the IOD contains a SOP Instance, Series Instance and Study Instance UID. More...
virtual OFCondition | importHierarchy (DcmItem &dataset, const OFBool readPatient, const OFBool readStudy, const OFBool readFoR=OFFalse, const OFBool readSeries=OFFalse, const OFBool takeOverCharset=OFTrue)
| Import common module attributes from dataset but only read Patient, Study, Series and/or Frame of Reference level portions. More...
virtual OFCondition | importHierarchy (const OFString &filename, const OFBool readPatient, const OFBool readStudy, const OFBool readFoR=OFFalse, const OFBool readSeries=OFFalse, const OFBool takeOverCharset=OFTrue)
| CAUTION: Parameter order (readFoR and readSeries) changed compared to the old import() function. More...
virtual OFBool | getValueCheckOnWrite () const
| Get whether attribute value errors will be handled as errors on writing. More...

## Protected Member Functions
| DPMParametricMapBase ()
| Constructor; not public since object should be create via factory method in derived class.
template<typename ImagePixel >
| DPMParametricMapBase (OFin_place_type_t(ImagePixel))
| Constructor; not public since object should be create via factory method in derived class.
virtual OFCondition | read (DcmItem &dataset)
| Read Parametric Map attributes (all those handled by this class) from given item. More...
virtual OFCondition | write (DcmItem &dataset)
| Write current Parametric Map's attributes to DICOM dataset. More...
virtual void | clearData ()
| Clear (removes) all attributes handled by the modules of this IOD. More...

## Static Protected Member Functions
static OFCondition | loadFile (DcmFileFormat &dcmff, const OFString &filename, DcmDataset *&dset)
| Loads file. More...

## Protected Attributes
FGInterface | m_FGInterface
| Multi-frame Functional Groups high level interface.
DPMParametricMapSeriesModule | m_DPMParametricMapSeriesModule
| Parametric Map Series Module.
IODEnhGeneralEquipmentModule | m_IODEnhGeneralEquipmentModule
| Enhanced General Equipment Module.
DPMParametricMapImageModule | m_DPMParametricMapImageModule
| Parametric Map Image Module.
IODMultiFrameFGModule | m_IODMultiFrameFGModule
| Multi-frame Functional Groups Module.
IODMultiframeDimensionModule | m_IODMultiframeDimensionModule
| Multi-frame Dimension Module.
IODAcquisitionContextModule | m_IODAcquisitionContextModule
| Acquisition Context Module.
IODCommonInstanceReferenceModule | m_IODCommonInstanceReferenceModule
| Common Instance Reference Module.

## Additional Inherited Members
Public Types inherited from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 >, IODFloatingPointImagePixelModule, IODDoubleFloatingPointImagePixelModule >
typedef DcmIODImage | IODImage
| typedef for old compilers that do not define the type 'DcmIODImage' in derived classes.
typedef IODImagePixelVariant< OFVARIADIC_TEMPLATE_PARAMETER_PACK(T)> | IODImagePixelModuleType
| A good comment would be nice, but I have nothing in mind.

## Detailed Description

Class for managing the Parametric Map IOD attributes.

Template parameter defines the type of pixel data to use: Unsigned or signed 16 bit integer, or 32 bit floating point, or 64 bit floating point data.

## Member Function Documentation

## ◆ check()

virtual OFBool DPMParametricMapBase::check | ( |  | ) |
| virtual

Perform some basic checking.

This method is also invoked when writing the object to a DICOM dataset or file.

Returns
  OFTrue, if no errors were found, OFFalse otherwise.

Reimplemented in DPMParametricMapIOD.

## ◆ clearData()

virtual void DPMParametricMapBase::clearData | ( |  | ) |
| protected virtual

Clear (removes) all attributes handled by the modules of this IOD.

IOD Rules are not reset.

Reimplemented from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 >, IODFloatingPointImagePixelModule, IODDoubleFloatingPointImagePixelModule >.

## ◆ getDPMParametricMapImageModule()

virtual DPMParametricMapImageModule& DPMParametricMapBase::getDPMParametricMapImageModule | ( |  | ) |
| virtual

Get Parametric Map Image Module.

Returns
  a reference to the Parametric Map Image Module

## ◆ getDPMParametricMapSeriesModule()

virtual DPMParametricMapSeriesModule& DPMParametricMapBase::getDPMParametricMapSeriesModule | ( |  | ) |
| virtual

Get Parametric Map Series Module.

Returns
  a reference to the Parametric Map Series Module

## ◆ getFunctionalGroups()

virtual FGInterface& DPMParametricMapBase::getFunctionalGroups | ( |  | ) |
| virtual

Get access to functional groups.

This is meant for reading data from functional groups that are not actively managed, i.e. made accessible by DcmSegmentation. In rare cases, however, it makes sense to access it for writing too, e.g. in order to add Stacks; use with care!

Returns
  Reference to the functional groups

## ◆ getIODAcquisitionContextModule()

virtual IODAcquisitionContextModule& DPMParametricMapBase::getIODAcquisitionContextModule | ( |  | ) |
| virtual

Get Acquisition Context Module.

Returns
  a reference to the Acquisition Context Module

## ◆ getIODCommonInstanceReferenceModule()

virtual IODCommonInstanceReferenceModule& DPMParametricMapBase::getIODCommonInstanceReferenceModule | ( |  | ) |
| virtual

Get Common Instance Reference Module.

Returns
  a reference to the Common Instance Reference Module

## ◆ getIODEnhGeneralEquipmentModule()

virtual IODEnhGeneralEquipmentModule& DPMParametricMapBase::getIODEnhGeneralEquipmentModule | ( |  | ) |
| virtual

Get Enhanced General Equipment Module.

Returns
  a reference to the Enhanced General Equipment Module

## ◆ getIODGeneralEquipmentModule()

virtual IODGeneralEquipmentModule& DPMParametricMapBase::getIODGeneralEquipmentModule | ( |  | ) |
| virtual

Get General Equipment Module.

Returns
  a reference to the General Equipment Module

## ◆ getIODGeneralImageModule()

virtual IODGeneralImageModule& DPMParametricMapBase::getIODGeneralImageModule | ( |  | ) |
| virtual

Get General Image Module.

Returns
  a reference to the General Image Module

## ◆ getIODGeneralSeriesModule()

virtual IODGeneralSeriesModule& DPMParametricMapBase::getIODGeneralSeriesModule | ( |  | ) |
| virtual

Get General Series Module.

Returns
  a reference to the IOD General Series Module

## ◆ getIODGeneralStudyModule()

virtual IODGeneralStudyModule& DPMParametricMapBase::getIODGeneralStudyModule | ( |  | ) |
| virtual

Get General Study Module.

Returns
  a reference to the IOD General Study Module

## ◆ getIODMultiframeDimensionModule()

virtual IODMultiframeDimensionModule& DPMParametricMapBase::getIODMultiframeDimensionModule | ( |  | ) |
| virtual

Get Multi-frame Dimension Module.

Returns
  a reference to the Multi-frame Dimension Module

## ◆ getIODMultiFrameFGModule()

virtual IODMultiFrameFGModule& DPMParametricMapBase::getIODMultiFrameFGModule | ( |  | ) |
| virtual

Get Multi-frame Functional Groups Module.

Returns
  a reference to the Multi-frame Functional Groups Module

## ◆ getIODPatientModule()

virtual IODPatientModule& DPMParametricMapBase::getIODPatientModule | ( |  | ) |
| virtual

Get Patient Module.

Returns
  a reference to the IOD Patient Module

## ◆ getIODPatientStudyModule()

virtual IODPatientStudyModule& DPMParametricMapBase::getIODPatientStudyModule | ( |  | ) |
| virtual

Get Patient Study Module.

Returns
  a reference to the IOD Patient Study Module

## ◆ getIODSOPCommonModule()

virtual IODSOPCommonModule& DPMParametricMapBase::getIODSOPCommonModule | ( |  | ) |
| virtual

Get SOP Common Module.

Returns
  a reference to the SOP Common Module

## ◆ loadFile()

static OFCondition DPMParametricMapBase::loadFile | ( | DcmFileFormat & | dcmff,
|  | const OFString & | filename,
|  | DcmDataset *& | dset
| ) |  |
| static protected

Loads file.

Parameters

  dcmff | The file format to load into
  filename | The filename of the file to load
  dset | Pointer to dataset after loading

Returns
  EC_Normal if loading was successful, error otherwise

## ◆ read()

virtual OFCondition DPMParametricMapBase::read | ( | DcmItem & | dataset | ) |
| protected virtual

Read Parametric Map attributes (all those handled by this class) from given item.

Reads attributes from base class DcmIODCommon before. The current content is deleted even if the reading process fails. If the log stream is set and valid the reason for any error might be obtained from the error/warning output.

Parameters

  dataset | Reference to DICOM dataset from which the document should be read

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 >, IODFloatingPointImagePixelModule, IODDoubleFloatingPointImagePixelModule >.

Reimplemented in DPMParametricMapIOD.

## ◆ saveFile()

virtual OFCondition DPMParametricMapBase::saveFile | ( | const OFString & | filename,
|  | const E_TransferSyntax | writeXfer = `EXS_LittleEndianExplicit`
| ) |  |
| virtual

Save current object to given filename.

Parameters

  filename | The file to write to
  writeXfer | The transfer syntax to be used

Returns
  EC_Normal if writing was successful, error otherwise.

## ◆ write()

virtual OFCondition DPMParametricMapBase::write | ( | DcmItem & | dataset | ) |
| protected virtual

Write current Parametric Map's attributes to DICOM dataset.

Also writes attributes of base class DcmIODCommon afterwards.

Parameters

  dataset | Reference to DICOM dataset to which the current document should be written. The dataset is not cleared before writing to it!

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 >, IODFloatingPointImagePixelModule, IODDoubleFloatingPointImagePixelModule >.

Reimplemented in DPMParametricMapIOD.

## ◆ writeDataset()

OFCondition DPMParametricMapBase::writeDataset | ( | DcmItem & | dataset | ) |

Write current object to given item.

Parameters

  dataset | The item to write to

Returns
  EC_Normal if writing was successful, error otherwise.

The documentation for this class was generated from the following file:

- dcmpmap/include/dcmtk/dcmpmap/dpmparametricmapbase.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1